<template>
  <svn-dialog-skeleton
    bind
    ref="dialog"
    title="Edit profile photo"
    icon="material-symbols:edit-outline-rounded"
    :dialog-custom-class="dialogCustomClass"
    secondary-button-text="Delete current photo"
    primary-button-text="Import photo"
    secondary-button-danger
    @click-primary-button="upload"
    @click-secondary-button="deletePicture"
    :primary-button-close-on-click="false"
    :vertical="false"
  >
    <template #activator>
      <slot name="activator" />
    </template>
    <template #primary-button-text>
      Import photo
      <v-file-input
        ref="avatar"
        type="file"
        accept="image/*"
        class="d-none"
        @change="uploadFile()"
      />
    </template>
  </svn-dialog-skeleton>
</template>

<script setup>
import {ref} from "vue";
import SvnDialogSkeleton from "../skeleton/SvnDialogSkeleton.vue";

const emit = defineEmits(['uploadFile', 'deletePicture'])
const avatar = ref(null);
const dialog = ref(null);
const uploadedAvatar = ref(null);

const props = defineProps({
  dialogCustomClass: {
    type: String,
    default: 'w-[400px]'
  }
})

const upload = async () => {
  avatar.value.click();
}

const uploadFile = async () => {
  if ( dialog.value ) {
    dialog.value.dialog = false
  }

  uploadedAvatar.value = URL.createObjectURL(avatar.value.files[0])

  emit('uploadFile', avatar.value.files[0])
};

const deletePicture = () => {
  emit('deletePicture')
}

defineExpose({
  dialog,
  uploadedAvatar
})
</script>
